#include <bits/stdc++.h>
using namespace std;
using ll=long long;
int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n,k,x;
    cin>>n>>k>>x;
    vector<ll> p(n);
    vector<ll> pref(n+1, 0);
    for(int i=0; i<n; i++){
        cin>>p[i];
        pref[i+1]=pref[i]+p[i];
    }
    for(int i=0; i<=n-k; i++){
        ll osn_s=pref[i+k]-pref[i];
        if(x==1) cout<<osn_s<<" ";
        vector<ll> suf;
        suf.reserve(k);
        for(int j=1; j<k; j++){
            suf.push_back(pref[i+k]-pref[i+j]);
        }
        nth_element(suf.begin(), suf.begin()+x-2, suf.end(), greater<ll>());
        ll ultra_max_sigma_aura=osn_s;
        for(int j=0; j<x-1; j++){
            ultra_max_sigma_aura+=suf[j];
        }
        cout<<ultra_max_sigma_aura<<" ";
    }
}